// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from smacc2_msgs:msg/SmaccTransitionLogEntry.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_TRANSITION_LOG_ENTRY__STRUCT_HPP_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_TRANSITION_LOG_ENTRY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'transition'
#include "smacc2_msgs/msg/detail/smacc_transition__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__smacc2_msgs__msg__SmaccTransitionLogEntry __attribute__((deprecated))
#else
# define DEPRECATED__smacc2_msgs__msg__SmaccTransitionLogEntry __declspec(deprecated)
#endif

namespace smacc2_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SmaccTransitionLogEntry_
{
  using Type = SmaccTransitionLogEntry_<ContainerAllocator>;

  explicit SmaccTransitionLogEntry_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    transition(_init)
  {
    (void)_init;
  }

  explicit SmaccTransitionLogEntry_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    transition(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _transition_type =
    smacc2_msgs::msg::SmaccTransition_<ContainerAllocator>;
  _transition_type transition;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__transition(
    const smacc2_msgs::msg::SmaccTransition_<ContainerAllocator> & _arg)
  {
    this->transition = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> *;
  using ConstRawPtr =
    const smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__smacc2_msgs__msg__SmaccTransitionLogEntry
    std::shared_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__smacc2_msgs__msg__SmaccTransitionLogEntry
    std::shared_ptr<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SmaccTransitionLogEntry_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->transition != other.transition) {
      return false;
    }
    return true;
  }
  bool operator!=(const SmaccTransitionLogEntry_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SmaccTransitionLogEntry_

// alias to use template instance with default allocator
using SmaccTransitionLogEntry =
  smacc2_msgs::msg::SmaccTransitionLogEntry_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace smacc2_msgs

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_TRANSITION_LOG_ENTRY__STRUCT_HPP_
