// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from smacc2_msgs:srv/SmaccGetTransitionHistory.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__STRUCT_HPP_
#define SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Request __attribute__((deprecated))
#else
# define DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Request __declspec(deprecated)
#endif

namespace smacc2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SmaccGetTransitionHistory_Request_
{
  using Type = SmaccGetTransitionHistory_Request_<ContainerAllocator>;

  explicit SmaccGetTransitionHistory_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit SmaccGetTransitionHistory_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Request
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Request
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SmaccGetTransitionHistory_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const SmaccGetTransitionHistory_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SmaccGetTransitionHistory_Request_

// alias to use template instance with default allocator
using SmaccGetTransitionHistory_Request =
  smacc2_msgs::srv::SmaccGetTransitionHistory_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace smacc2_msgs


// Include directives for member types
// Member 'history'
#include "smacc2_msgs/msg/detail/smacc_transition_log_entry__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Response __attribute__((deprecated))
#else
# define DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Response __declspec(deprecated)
#endif

namespace smacc2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SmaccGetTransitionHistory_Response_
{
  using Type = SmaccGetTransitionHistory_Response_<ContainerAllocator>;

  explicit SmaccGetTransitionHistory_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit SmaccGetTransitionHistory_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _history_type =
    std::vector<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>>;
  _history_type history;

  // setters for named parameter idiom
  Type & set__history(
    const std::vector<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<smacc2_msgs::msg::SmaccTransitionLogEntry_<ContainerAllocator>>> & _arg)
  {
    this->history = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Response
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__smacc2_msgs__srv__SmaccGetTransitionHistory_Response
    std::shared_ptr<smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SmaccGetTransitionHistory_Response_ & other) const
  {
    if (this->history != other.history) {
      return false;
    }
    return true;
  }
  bool operator!=(const SmaccGetTransitionHistory_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SmaccGetTransitionHistory_Response_

// alias to use template instance with default allocator
using SmaccGetTransitionHistory_Response =
  smacc2_msgs::srv::SmaccGetTransitionHistory_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace smacc2_msgs

namespace smacc2_msgs
{

namespace srv
{

struct SmaccGetTransitionHistory
{
  using Request = smacc2_msgs::srv::SmaccGetTransitionHistory_Request;
  using Response = smacc2_msgs::srv::SmaccGetTransitionHistory_Response;
};

}  // namespace srv

}  // namespace smacc2_msgs

#endif  // SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__STRUCT_HPP_
